//+------------------------------------------------------------------+
//|                                         Group23A_Capstone_EA.mq4 |
//|                                               Capstone Group 23A |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Capstone Group 23A"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#include <stdlib.mqh>
#include <stderror.mqh>
// ----------  ON C A N D L E    T I M E
string Timer                        =  "  Candle Time";
extern color  TimerColor            =  clrAqua;            // Time Left Color
extern int    TimerFontSize         =  10;                 // Time Left Font Size

//---Define Custom indicator colors and sizes
extern color FibLineColor=clrYellow;

//--Trade Risk
extern double SetPercentRisk        =  1.0;              //Max amount of Account Risk

extern int lookback                 =  24;               //Look back a specific number of bars
extern int lastbar                  =  0;

//---Broker Pips 3 or 5
double pips;

extern int Slippage=30;
extern int MagicNumber=1234;
//--Break Even Settings
extern bool UseMoveToBE = true;//Do you want to use Move to Breakeven?
extern int WhenToMoveToBE =15;//How many pips before you move?
extern int PipsToLockIn = 1;//How many pips do you want to lock in?
//--Trailing Stop Settings
extern bool UseTrailingStop         = true;//Do you want to use Trailing Stops?
extern int WhenToTrail              = 10;//How many pips before you move?
extern int TrailAmount              = 15;//How many pips do you want to lock in?

extern int MaxNumberofTrades        =  1;


//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {

//--- Determine what decimal places are for teh broker
   pips=Point;
   if(Digits==3 || Digits==5)
      pips*=10;

//#include<OnInit_CHECKS.mqh>
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----  Delete Fib Lines
   ObjectDelete("Fibo");
//----   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(UseTrailingStop)AdjustTrail();
   if(UseMoveToBE)MovetoBreakeven();//Check each tick to determine if the SL is at BE
   int    counted_bars=IndicatorCounted();

//----
   double lowest=1000;
   double highest=0;
   datetime T1,T2;

   double StopLoss;
   double TakeProfit;
   double Entry;

//int ticket;

   for(int i=lookback+lastbar;i>lastbar+1;i--)
     {
      double curLow0=iLow(Symbol(),Period(),i-2);
      double curLow1=iLow(Symbol(),Period(),i+1);
      double curLow2=iLow(Symbol(),Period(),i);          // Look here for swing point variable 
      double curLow3=iLow(Symbol(),Period(),i-1);
      double curLow4=iLow(Symbol(),Period(),i-2);

      double curHigh0=iHigh(Symbol(),Period(),i+2);
      double curHigh1=iHigh(Symbol(),Period(),i+1);
      double curHigh2=iHigh(Symbol(),Period(),i);        // Look here for swing point variable
      double curHigh3=iHigh(Symbol(),Period(),i-1);
      double curHigh4=iHigh(Symbol(),Period(),i-2);

      if(curLow2<=curLow1 && curLow2<=curLow3 && curLow2<=curLow4)
        {
         if(lowest>curLow2)
           {
            lowest=curLow2;
            T2=iTime(Symbol(),Period(),i);
           }
        }

      if(curHigh2>=curHigh1 && curHigh2>=curHigh3 && curHigh2>=curHigh4)
        {
         if(highest<curHigh2)
           {
            highest=curHigh2;
            T1=iTime(Symbol(),Period(),i);
           }
        }
     }

//---PipDiff
   double PipDiff=((highest-lowest)*10000);

   if(T1<T2)//SELL
     {
      ObjectCreate("Fibo",OBJ_FIBO,0,T1,highest,T2,lowest);

      //---Calculate SL
      StopLoss=((highest-lowest)*0.8)+lowest; //THIS WORKS
      //---Calculate TP
      TakeProfit=lowest-(highest-lowest)*0.618;//THIS WORKSSS!!!
      //---Determine Entry
      Entry=lowest-(highest-lowest)*-0.618;//THIS WORKSSS!!!

     }
   else //BUY
     {
      ObjectCreate("Fibo",OBJ_FIBO,0,T2,lowest,T1,highest);

      //---Calculate SL     
      StopLoss=((lowest-highest)*0.8)+highest; //THIS WORKS
      //---Calculate TP
      TakeProfit=highest+(highest-lowest)*0.618; //THIS WORKSSS!!!
      //---Determine Entry
      Entry=highest+(highest-lowest)*-0.618;//THIS WORKSSS!!!

     }

//----DISPLAY FIB LINES ON CHART

   string fiboobjname="Fibo";

   ObjectSet(fiboobjname,OBJPROP_FIBOLEVELS,10); //Set 11 lines of the Fib

   ObjectSet(fiboobjname,OBJPROP_FIRSTLEVEL,0.0);
   ObjectSetFiboDescription(fiboobjname,0,"0.0             %$");
   ObjectSet(fiboobjname,OBJPROP_FIRSTLEVEL+2,0.382);
   ObjectSetFiboDescription(fiboobjname,2,"38.2     %$");
   ObjectSet(fiboobjname,OBJPROP_FIRSTLEVEL+3,0.50);
   ObjectSetFiboDescription(fiboobjname,3,"50.0     %$");
   ObjectSet(fiboobjname,OBJPROP_FIRSTLEVEL+4,0.618);
   ObjectSetFiboDescription(fiboobjname,4,"ENTRY PRICE      61.8     %$");
   ObjectSet(fiboobjname,OBJPROP_FIRSTLEVEL+5,0.80);
   ObjectSetFiboDescription(fiboobjname,5,"STOP LOSS        80.0     %$");
   ObjectSet(fiboobjname,OBJPROP_FIRSTLEVEL+6,1.000);
   ObjectSetFiboDescription(fiboobjname,6,"100.0     %$");
   ObjectSet(fiboobjname,OBJPROP_FIRSTLEVEL+7,-0.382);
   ObjectSetFiboDescription(fiboobjname,7,"1.382     %$");
   ObjectSet(fiboobjname,OBJPROP_FIRSTLEVEL+8,-0.618);
   ObjectSetFiboDescription(fiboobjname,8,"TAKE PROFIT     1.618     %$");

   ObjectSet("Fibo",OBJPROP_LEVELCOLOR,FibLineColor);
   ObjectsRedraw();

//---ACCOUNT BALANCE CALCULATION   

   double AccBalance=(AccountBalance()*(SetPercentRisk)/100);
//Comment("1% of Account Balance is: ", AccBalance);
   double StopVal  = ((highest-lowest)*0.200)*10000; //THIS WORKS
   double EntryVal = ((highest-lowest)*0.382)*10000; //This Calc is not functioning for some reason??

//---DIFFERENCE IN PIPS BETWEEN ENTRY AND EXIT  

   double PipDiffEnt=(EntryVal-StopVal);
//Comment ("Diff in Pips is: ", PipDiffEnt);
   EntryVal=(StopVal+(PipDiffEnt/1000));

//---CALCULATE NUMBER OF TRADE LOTS   

   double Lots=(AccBalance/PipDiffEnt)/10;  //Divide by 10 for a mini-Lot

//---COMMENTS ON SCREEN FOR LOTS, ENTRY, SL and TP

   Comment("\nNumber of Lots is:  ",Lots,
           "\n\nEntry is: ",Entry,
           "\n\nStop Loss is: ",StopLoss,
           "\n\nTake Profit  is: ",TakeProfit,
           "\n\nDifference in Pips: ",PipDiffEnt);
//Comment("Entry: ",Entry);

   if(T1>T2)//SELL
      EnterTrade(OP_BUY,Entry,Lots,StopLoss,TakeProfit);
   else //BUY
   EnterTrade(OP_SELL,Entry,Lots,StopLoss,TakeProfit);



   }//--OnTick Function END
//+--------------------------------------------------------------------------------------------------------------------+
//|                                             FUNCTION CALLS                                                         |
//+--------------------------------------------------------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Trade Placing Function                                           |
//+------------------------------------------------------------------+

void EnterTrade(int type,double fibEntry,double lot,double SL,double TP)
  {
   double price=Bid;
   if(type==OP_BUY)
      price=Ask;

//--
   if(TotalOpenOrders()<MaxNumberofTrades)
     {
      int entryTicket=OrderSend(Symbol(),type,lot,fibEntry,Slippage,SL,TP,"Group23A_EA Trade",MagicNumber,0,clrYellow);
     }
  }
//+------------------------------------------------------------------+
//|  THIS FUNCTION IS FOR TAKING ONE TRADE AT A TIME!!!              |
//+------------------------------------------------------------------+

int TotalOpenOrders()
  {
   int total=0;
   for(int i=OrdersTotal()-1;i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         total++;
      else
         Print("Failed to select order",GetLastError());
     }
   return (total);
  }
//+------------------------------------------------------------------+
//| Move to Break Even Function                                       |
//+------------------------------------------------------------------+
	
void	MovetoBreakeven(){
   for(int i=OrdersTotal()-1; i >= 0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderMagicNumber()== MagicNumber)
            if(OrderType()==OP_BUY){
               if(Bid-OrderOpenPrice()>WhenToMoveToBE*pips)
                  if(OrderStopLoss()<OrderOpenPrice())
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(PipsToLockIn*pips),OrderTakeProfit(),0,CLR_NONE)){
                        int err = GetLastError();
                        Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
                     }
            }
            else if(OrderType()==OP_SELL){
               if(OrderOpenPrice()-Ask>WhenToMoveToBE*pips)
                  if(OrderStopLoss()>OrderOpenPrice())
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(PipsToLockIn*pips),OrderTakeProfit(),0,CLR_NONE)){
                        int err = GetLastError();
                        Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );   
                     }
            }
       }
      else{//in case it fails to select an order.
      int err = GetLastError();
      Print("Encountered an error during order selection in: "+ __FUNCTION__+"!"+(string)err+" "+ErrorDescription(err)  );
      }
   }
}

//+------------------------------------------------------------------+
//| Trailing Stop Function                                       |
//+------------------------------------------------------------------+
	
void	AdjustTrail(){
for(int i=OrdersTotal()-1; i >= 0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderMagicNumber()== MagicNumber)
            if(OrderType()==OP_BUY){
               if(Bid-OrderOpenPrice() > WhenToTrail*pips)
                  if(OrderStopLoss() < Bid - TrailAmount*pips)
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(TrailAmount*pips),OrderTakeProfit(),0,CLR_NONE)){
                        int err = GetLastError();
                        Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
                     }// for the order modify section
            } //for Buy Order
            else if (OrderType()==OP_SELL){
            if(OrderOpenPrice() - Ask > WhenToTrail*pips)
                  if(OrderStopLoss() > Ask + TrailAmount*pips)
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask + (TrailAmount*pips),OrderTakeProfit(),0,CLR_NONE)){
                        int err = GetLastError();
                        Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );   
                     }
            
            }// for Sell Order
      }
   }
}
//|--------------------------------------------------------------------------------------------------------------------|
//|                                            E N D                                                                   |
//|--------------------------------------------------------------------------------------------------------------------|
